'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.responderSendDebugPage = exports.responderSendFavicon = undefined;

var _Dr = require('dr-js/library/Dr.node');

const { Server: { Responder: { responderSendBuffer } } } = _Dr.Node;

const responderSendFavicon = store => responderSendBuffer(store, { buffer: Buffer.from('iVBORw0KGgoAAAANSUhEUgAAAAEAAAABAQMAAAAl21bKAAAAA1BMVEVjrv/wbTZJAAAACklEQVQI12NgAAAAAgAB4iG8MwAAAABJRU5ErkJggg==', 'base64'), type: 'image/png' });
const responderSendDebugPage = store => responderSendBuffer(store, { buffer: Buffer.from(STRING_DEBUG_HTML), type: 'text/html' });

const STRING_DEBUG_HTML = `<!DOCTYPE html>
<meta charset="utf-8">
<meta name="viewport" content="minimum-scale=1, width=device-width">
<script>
window.getTaskStatus = () => fetch('/status?verbose&pretty', { method: 'GET' }).then((res) => res.json()).then((taskStatusList) => {
  console.log(taskStatusList)
  document.getElementById('status').innerHTML = JSON.stringify(taskStatusList, null, ' ')
})
window.getTaskStatusDetail = () => fetch('/status?verbose', { method: 'GET' }).then((res) => res.json()).then((taskStatusList) => {
  console.log(taskStatusList)
  document.getElementById('status').innerHTML = JSON.stringify(taskStatusList, null, ' ')
})
window.startDebugTask = (taskData = performance.now().toString(36)) => {
  fetch('/task', { method: 'POST', body: JSON.stringify({taskData}) }).then((res) => res.text()).then((text) => {
    console.log(taskData, text)
    document.getElementById('log').innerHTML += '\\n[Task] ' + taskData + ' | ' + text
  })
}
window.startDebugTask10 = () => { for (let i = 0; i < 10; i++) window.startDebugTask() }
window.startDebugSyncTask = (taskData = performance.now().toString(36)) => {
  document.getElementById('log').innerHTML += '\\n[SyncTask] start: ' + taskData
  fetch('/task-sync', { method: 'POST', body: JSON.stringify({ taskData }) }).then((res) => res.text()).then((text) => {
    console.log(taskData, text)
    document.getElementById('log').innerHTML += '\\n[SyncTask] end: ' + taskData + ' | ' + text
  })
}
window.resetLog = () => { document.getElementById('log').innerHTML = 'LOG' }
</script>
<button onclick="getTaskStatus()">getTaskStatus</button>
<button onclick="getTaskStatusDetail()">getTaskStatusDetail</button>
<button onclick="startDebugTask()">startDebugTask</button>
<button onclick="startDebugTask10()">startDebugTask10</button>
<button onclick="startDebugSyncTask()">startDebugSyncTask</button>
<button onclick="resetLog()">resetLog</button>
<pre style="display: flex; flex-flow: row; font-size: 12px;">
  <div id="status" style="border-right: 2px solid #eee;">STATUS</div>
  <div id="log">LOG</div>
</pre>`;

exports.responderSendFavicon = responderSendFavicon;
exports.responderSendDebugPage = responderSendDebugPage;