'use strict';

var _configure = require('./configure');

var _option = require('./option');

const main = async () => {
  const { optionMap, getSingleOption, getSingleOptionOptional } = await (0, _option.parseOption)();

  return (0, _configure.configure)({
    hostname: getSingleOption(optionMap, 'hostname'),
    port: getSingleOption(optionMap, 'port'),
    filePid: getSingleOptionOptional(optionMap, 'file-pid'),
    pathLog: getSingleOptionOptional(optionMap, 'path-log'),
    logFilePrefix: getSingleOptionOptional(optionMap, 'prefix-log-file'),
    urlServerPingTest: getSingleOption(optionMap, 'url-server-ping-test'),
    urlSnapshotApp: getSingleOption(optionMap, 'url-snapshot-app'),
    urlSnapshotTask: getSingleOption(optionMap, 'url-snapshot-task'),
    taskRunnerCount: getSingleOption(optionMap, 'task-runner-count'),
    taskRunnerDebugOnly: Boolean(getSingleOptionOptional(optionMap, 'task-runner-debug-only'))
  }).catch(error => {
    console.warn(error);
    process.exit(2);
  });
};

main().catch(_option.exitWithError);