'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearPuppeteerBrowser = exports.initPuppeteerBrowser = exports.createTaskRunnerDebug = exports.createTaskRunnerPuppeteer = undefined;

var _Dr = require('dr-js/library/Dr.node');

var _utils__ = require('../__utils__');

var _taskRunnerPuppeteer = require('./taskRunnerPuppeteer');

var _taskRunnerDebug = require('./taskRunnerDebug');

const { Module: { createTaskRunner, createTaskRunnerCluster } } = _Dr.Common;

const createTaskRunnerPuppeteer = async ({ urlSnapshotApp, urlServerPingTest, puppeteerBrowser, logger, clusterSize }) => {
  const taskRunnerOption = (0, _taskRunnerPuppeteer.getTaskRunnerOptionPuppeteer)({ urlSnapshotApp, urlServerPingTest, puppeteerBrowser, logger });
  return createTaskRunnerCluster({
    clusterSize,
    getRunnerFromTaskId: (taskRunnerList, taskId) => {
      const result = taskId && /^TSS-(\d)-/.exec(taskId);
      return result && taskRunnerList[parseInt(result[1], 36)];
    },
    createTaskRunner: async (clusterIndex = 0) => createTaskRunner(Object.assign({}, taskRunnerOption, {
      getTaskId: inputData => `TSS-${clusterIndex.toString(36)}-${(0, _utils__.getJSONHash)(inputData)}`
    }))
  });
};

const createTaskRunnerDebug = async ({ logger, clusterSize }) => {
  const taskRunnerOption = (0, _taskRunnerDebug.getTaskRunnerOptionDebug)({ logger });
  return createTaskRunnerCluster({
    clusterSize,
    getRunnerFromTaskId: (taskRunnerList, taskId) => {
      const result = taskId && /^TASK-DEBUG-(\d)-/.exec(taskId);
      return result && taskRunnerList[parseInt(result[1], 36)];
    },
    createTaskRunner: async (clusterIndex = 0) => createTaskRunner(Object.assign({}, taskRunnerOption, {
      getTaskId: inputData => `TASK-DEBUG-${clusterIndex.toString(36)}-${(0, _utils__.getJSONHash)(inputData)}`
    }))
  });
};

exports.createTaskRunnerPuppeteer = createTaskRunnerPuppeteer;
exports.createTaskRunnerDebug = createTaskRunnerDebug;
exports.initPuppeteerBrowser = _taskRunnerPuppeteer.initPuppeteerBrowser;
exports.clearPuppeteerBrowser = _taskRunnerPuppeteer.clearPuppeteerBrowser;