'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTaskRunnerOptionDebug = undefined;

var _Dr = require('dr-js/library/Dr.node');

const { Math: { getRandomInt }, Time: { setTimeoutAsync } } = _Dr.Common;

const getTaskRunnerOptionDebug = ({ logger }) => ({
  clearRunner: () => {},
  resetRunner: (error, taskId) => error && logger.add(`[DebugTaskRunner|${taskId}] error: ${error.stack || error.toString()}`),
  getTaskInitialState: task => task,
  runTask: async (taskId, { getTaskState, updateTaskState }) => {
    logger.add(`[DebugTaskRunner|${taskId}] start`);
    logger.add(JSON.stringify(getTaskState(taskId).inputData));
    for (let index = 0, indexMax = getRandomInt(5, 10); index < indexMax; index++) {
      await setTimeoutAsync(500);
      logger.add(`[DebugTaskRunner|${taskId}] step [${index}/${indexMax}]`);
      if (indexMax === 8 && index === 4) throw new Error('[DebugError] at 4 of 8');
      updateTaskState(taskId, { progress: Math.round(100 * (index + 1) / indexMax) });
    }
    logger.add(`[DebugTaskRunner|${taskId}] complete`);
    return { output: 'DebugTaskRunner' };
  }
});

exports.getTaskRunnerOptionDebug = getTaskRunnerOptionDebug;